<?php

namespace ISYS\UBRIR;

$curDir = dirname(__FILE__);
$moduleDir = realpath($curDir . '/../');

use UBRIR\CMS_PaymentCallback;

class OpencartCallback extends CMS_PaymentCallback
{
    private $controller;

    function __construct(\Controller $controller)
    {
        $this->controller = $controller;

        $connector = new OpencartUBRiRConnector($controller);
        parent::__construct($connector);
    }

    public function OnPaymentApproved($shopOrderId, $sessionId)
    {
        $this->controller->load->model('checkout/order');

        $ubrr_order_status_id = $this->controller->config->get('ubrr_order_status_id');
        $this->controller->model_checkout_order->addOrderHistory($shopOrderId, $ubrr_order_status_id);

        return true;
    }

    public function OnPaymentCanceled($shopOrderId, $sessionId)
    {
        return false;
    }

    public function OnPaymentDeclined($shopOrderId, $sessionId)
    {

        return false;
    }

}