<?php

use ISYS\UBRIR\OpencartAdmin;
use ISYS\UBRIR\OpencartCallback;
use ISYS\UBRIR\OpencartPayment;
use ISYS\UBRIR\OpencartUBRiRConnector;
use UBRIR\NewCertificates;

$currentDir = dirname(__FILE__) . '/';
include_once($currentDir . 'classes/_autoload.php');
include_once($currentDir . 'ubrr.core/_autoload.php');


class ControllerExtensionPaymentUbrr extends Controller
{
    public function __construct($registry)
    {
        parent::__construct($registry);
        $this->load->language('extension/payment/ubrr');
    }

    public function index()
    {
        $this->load->language('extension/payment/ubrr');

        //LoadLanguage
        $data['text_testmode'] = $this->language->get('text_testmode');
        $data['button_confirm'] = $this->language->get('button_confirm');

        //LoadParams
        $data['order_id'] = $this->session->data['order_id'];

        $actionURL = $this->url->link('extension/payment/ubrr/confirm');
        $data['action'] = $actionURL;

        $this->load->model('checkout/order');
        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);

        if ($order_info) {
            $data['currency'] = $order_info['currency_code'];

            $total = $this->currency->format($order_info['total'], $order_info['currency_code'], false, false);
            $data['order_amount'] = $total;
        }

        return $this->load->view('extension/payment/ubrr', $data);
    }

    public function confirm()
    {
        if ($this->session->data['payment_method']['code'] == 'ubrr') {
            $cmsModule = new OpencartPayment($this);

            //Готовимся оплачивать
            $orderId = $this->session->data['order_id'];

            $this->load->model('checkout/order');
            $orderInfo = $this->model_checkout_order->getOrder($orderId);
            $orderAmount = $orderInfo['total'];

            $order_confirm_status_id = $this->config->get('ubrr_order_confirm_status_id');
            $this->model_checkout_order->addOrderHistory($orderId, $order_confirm_status_id);

            $callbackURL = $this->url->link('extension/payment/ubrr/callback');
            $response = $cmsModule->SetupAndPrepareToPay($orderId, $orderAmount, $callbackURL);

            //Подготовка прошла успешно
            if ($response->isSuccess()) {
                $PaymentURL = $response->getFieldValue('Url');
                $TWPG_OrderId = $response->getFieldValue('OrderId');
                $SessionId = $response->getFieldValue('SessionId');

                $cmsModule->SaveTWPGOrder($orderId, $TWPG_OrderId, $SessionId);


                echo '<meta http-equiv="Refresh" content="0; url=' . $PaymentURL . '?orderid=' . $TWPG_OrderId . '&sessionid=' . $SessionId . '">';
            } else {
                $cmsModule->ShowPaymentError($callbackURL);
            }
        }
    }

    public function callback()
    {
        $openCartModule = new OpencartCallback($this);

        $openCartModule->ProcessCallbackResponse();
        $openCartModule->ShowCallbackProcessResult();
    }

}