$(document).ready(function () {
    Admin_UBRR.Init();
});

(function () {
    var Admin_UBRR = {};
    window['Admin_UBRR'] = Admin_UBRR;

    var Cert = {};
    Admin_UBRR['Cert'] = Cert;

    var FileUploader = {};
    Admin_UBRR['FileUploader'] = FileUploader;

    var d = {};


    Admin_UBRR['Ajax'] = function (request_type, ajax_data, callback, error_callback) {
        var jData = {};
        if (typeof(ajax_data) === 'object') {
            jData = ajax_data;
        }
        jData['ajax_type'] = request_type;

        jQuery.ajax({
            url: location.href,
            type: 'GET',
            data: jData,
            success: function (r) {
                if (typeof (callback) === 'function') {
                    callback(r);
                }
            },
            error: function (r) {
                if (typeof(error_callback) === 'function') {
                    error_callback(r);
                }
            }
        })
    };


    Admin_UBRR['Init'] = function () {
        Cert.Init();
        FileUploader.Init();
    };

    Cert['Init'] = function () {
        $('form#getCertRequest').on('submit', function (event) {
            event.preventDefault();
            var emailFrom = $('input[name=emailFrom]').val();
            var emailTo = $('input[name=emailTo]').val();
            var country = $('input[name=country]').val();
            var region = $('input[name=region]').val();
            var city = $('input[name=city]').val();
            var organization = $('input[name=organization]').val();
            var division = $('input[name=division]').val();
            var merchantId = $('input[name=merchantId]').val();
            var keyPass = $('input[name=keyPass]').val();
            var data = {
                'emailFrom': emailFrom,
                'emailTo': emailTo,
                'country': country,
                'region': region,
                'city': city,
                'organization': organization,
                'division': division,
                'merchantId': merchantId,
                'keyPass': keyPass
            };
            Admin_UBRR.Ajax('certificate_generate', data, function (response) {
                var statusPlace = jQuery('#certStatus');
                var createdPlace = jQuery('#certCreatedDate');
                Cert.GetCertStatus_Success(response, statusPlace, createdPlace);
            })
        })
    };
    Cert['GetCertStatus_Success'] = function (response, statusPlace, createdPlace) {
        statusPlace.html($('<span>' + response + '</span>'));

    };


    FileUploader['Init'] = function () {
        $('form#uploadCertificate').on('submit', function (event) {
            event.preventDefault();
            var form = $(this).get(0);
            $('#certificateUploadStatus').html('');

            var formData = new FormData(form);

            var xhr = new XMLHttpRequest();
            xhr.open("POST", form.getAttribute('action'));

            xhr.onreadystatechange = function () {
                if (xhr.readyState === 4) {
                    if (xhr.status === 200) {
                        data = xhr.responseText;
                        $('#certificateUploadStatus').html(data);
                    }
                }
            };

            xhr.send(formData);
        });
    }

})();